Skip to main content

List of Connectors with Expansions

GET 

/connect/v1/environments/:environment_id/clusters/:kafka_cluster_id/connectors?expand=info,status,id

General Availability

Retrieve an object with the queried expansions of all connectors. Without expand query parameter, this list connector’s endpoint will return a list of only the connector names.

Request

Responses

Connector.

OpenAPI definition (YAML)
paths:
  /connect/v1/environments/{environment_id}/clusters/{kafka_cluster_id}/connectors?expand=info,status,id:
    get:
      x-lifecycle-stage: General Availability
      operationId: listConnectv1ConnectorsWithExpansions
      description: '[![General Availability](https://img.shields.io/badge/Lifecycle%20Stage-General%20Availability-%2345c6e8)](#section/Versioning/API-Lifecycle-Policy)


        Retrieve an object with the queried expansions of all connectors. Without `expand` query parameter,
        this list connector’s endpoint will return a [list of only the connector names](#operation/listConnectv1Connectors).'
      tags:
      - Connectors (connect/v1)
      security:
      - cloud-api-key: []
      - confluent-sts-access-token: []
      responses:
        '200':
          description: Connector.
          content:
            application/json:
              schema:
                type: object
                additionalProperties:
                  type: object
                  description: Name of connector
                  properties:
                    id:
                      type: object
                      description: The ID of connector.
                      properties:
                        id:
                          type: string
                          description: The ID of the connector.
                        id_type:
                          type: string
                          description: Type of the value in the `id` property.
                    info:
                      type: object
                      description: Metadata of the connector.
                      properties:
                        name:
                          type: string
                          description: Name of the connector.
                        config:
                          type: object
                          description: "Configuration parameters for the connector. These configurations\n\
                            are the minimum set of key-value pairs (KVP) which are used to\ndefine how\
                            \ the connector connects Kafka to the external system.\nSome of these KVPs\
                            \ are common to all the connectors, such as\nconnection parameters to Kafka,\
                            \ connector metadata, etc. The list\nof common connector configurations is\
                            \ as follows\n\n  - cloud.environment\n  - cloud.provider\n  - connector.class\n\
                            \  - kafka.api.key\n  - kafka.api.secret\n  - kafka.endpoint\n  - kafka.region\n\
                            \  - name\n\nFor example, a connector like `GcsSink` would have additional\n\
                            parameters such as `gcs.bucket.name`, `flush.size`, etc."
                          required:
                          - cloud.environment
                          - cloud.provider
                          - connector.class
                          - name
                          - kafka.endpoint
                          - kafka.region
                          - kafka.api.key
                          - kafka.api.secret
                          properties:
                            cloud.environment:
                              type: string
                              description: The cloud environment type.
                            cloud.provider:
                              type: string
                              description: The cloud service provider, e.g. aws, azure, etc.
                              enum:
                              - aws
                              - azure
                              - gcp
                            connector.class:
                              type: string
                              description: The connector class name. E.g. BigQuerySink, GcsSink, etc.
                            name:
                              type: string
                              description: Name or alias of the class (plugin) for this connector.
                            kafka.endpoint:
                              type: string
                              description: The kafka cluster endpoint.
                            kafka.region:
                              type: string
                              description: The kafka cluster region.
                            kafka.api.key:
                              type: string
                              description: The kafka cluster api key.
                            kafka.api.secret:
                              type: string
                              description: The kafka cluster api secret key.
                              x-redact: true
                          additionalProperties:
                            type: string
                    status:
                      type: object
                      description: Status of the connector and its tasks.
                      properties:
                        name:
                          type: string
                          description: The name of the connector.
                        type:
                          type: string
                          description: Type of connector, sink or source.
                          enum:
                          - sink
                          - source
                        connector:
                          type: object
                          description: A map containing connector status.
                          required:
                          - state
                          - worker_id
                          properties:
                            state:
                              type: string
                              description: The state of the connector.
                              enum:
                              - NONE
                              - PROVISIONING
                              - RUNNING
                              - DEGRADED
                              - FAILED
                              - PAUSED
                              - DELETED
                            worker_id:
                              type: string
                              description: The worker ID of the connector.
                            trace:
                              type: string
                              description: Exception message in case of an error.
                        tasks:
                          type: array
                          description: A map containing the task status.
                          items:
                            type: object
                            properties:
                              id:
                                type: integer
                                description: The ID of task.
                              state:
                                type: string
                                description: The state of the task.
                              worker_id:
                                type: string
                                description: The worker ID of the task.
                              msg:
                                type: string
                            required:
                            - id
                            - state
                            - worker_id
                      required:
                      - name
                      - type
                      - connector
                  title: connect.v1.ConnectorExpansion
                title: connect.v1.ConnectorExpansionMap
              example:
                MyGcsLogsBucketConnector:
                  id:
                    id: lcc-xxxxx
                    id_type: ID
                  info:
                    name: MyGcsLogsBucketConnector
                    config:
                      cloud.environment: prod
                      cloud.provider: aws
                      connector.class: GcsSink
                      data.format: BYTES
                      flush.size: '1000'
                      gcs.bucket.name: APILogsBucket
                      gcs.credentials.config: '****************'
                      kafka.api.key: '****************'
                      kafka.api.secret: '****************'
                      kafka.endpoint: SASL_SSL://pkc-xxxxx.us-west-2.aws.confluent.cloud:9092
                      kafka.region: us-west-2
                      name: MyGcsLogsBucketConnector
                      tasks.max: '1'
                      time.interval: DAILY
                      topics: APILogsTopic
                      type: sink
                  status:
                    name: MyGcsLogsBucketConnector
                    connector:
                      state: PROVISIONING
                      worker_id: MyGcsLogsBucketConnector
                      trace: ''
                    tasks: []
                    type: sink
                MyS3BucketConnector:
                  id:
                    id: lcc-xxxxx
                    id_type: ID
                  info:
                    name: MyS3BucketConnector
                    config:
                      cloud.environment: prod
                      cloud.provider: aws
                      connector.class: S3Sink
                      data.format: BYTES
                      flush.size: '1000'
                      s3.bucket: APILogsBucket
                      aws.access.key.id: '************'
                      aws.secret.access.key: '**********'
                      kafka.api.key: '****************'
                      kafka.api.secret: '****************'
                      kafka.endpoint: SASL_SSL://pkc-xxxxx.us-west-2.aws.confluent.cloud:9092
                      kafka.region: us-west-2
                      name: MyS3BucketConnector
                      tasks.max: '1'
                      time.interval: DAILY
                      topics: APILogsTopic
                      type: source
                  status:
                    name: MyS3BucketConnector
                    connector:
                      state: FAILED
                      worker_id: MyS3BucketConnector
                      trace: 'There were some errors with your configuration:

                        topics: Provided Kafka ApiKey is invalid

                        kafka.api.secret: Provided Kafka ApiKey is invalid

                        '
                    tasks: []
                    type: sink
                MyDatagenConnector:
                  id:
                    id: lcc-xxxxx
                    id_type: ID
                  info:
                    name: MyDatagenConnector
                    config:
                      cloud.environment: prod
                      cloud.provider: aws
                      connector.class: DatagenSource
                      data.format: BYTES
                      flush.size: '1000'
                      quickstart: ORDERS
                      kafka.api.key: '****************'
                      kafka.api.secret: '****************'
                      kafka.endpoint: SASL_SSL://pkc-xxxxx.us-west-2.aws.confluent.cloud:9092
                      kafka.region: us-west-2
                      name: MyDatagenConnector
                      tasks.max: '1'
                      time.interval: DAILY
                      topics: APILogsTopic
                      type: source
                  status:
                    name: MyDatagenConnector
                    connector:
                      state: RUNNING
                      worker_id: MyDatagenConnector
                      trace: ''
                    tasks:
                    - id: 0
                      msg: ''
                      state: RUNNING
                      worker_id: MyDatagenConnector
                    type: source
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    description: Connector Error with error code and message.
                    properties:
                      code:
                        type: integer
                        description: Error code for the type of error
                      message:
                        type: string
                        description: Human readable error message
                title: connect.v1.ConnectorError
              example:
                error:
                  code: 401
                  message: Unauthorized
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    description: Connector Error with error code and message.
                    properties:
                      code:
                        type: integer
                        description: Error code for the type of error
                      message:
                        type: string
                        description: Human readable error message
                title: connect.v1.ConnectorError
              example:
                error:
                  code: 404
                  message: account not found
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    description: Connector Error with error code and message.
                    properties:
                      code:
                        type: integer
                        description: Error code for the type of error
                      message:
                        type: string
                        description: Human readable error message
                title: connect.v1.ConnectorError
              example:
                error:
                  code: 500
                  message: Oops, something went wrong
      parameters:
      - name: environment_id
        in: path
        schema:
          type: string
        required: true
        description: The unique identifier of the environment this resource belongs to.
      - name: kafka_cluster_id
        in: path
        schema:
          type: string
        required: true
        description: The unique identifier for the Kafka cluster.
      - name: expand
        in: query
        description: '- id : Returns metadata of each connector such as id and id type.

          - info : Returns metadata of each connector such as the configuration, task

          information, and type of connector.

          - status : Returns additional state information of each connector including their status and
          tasks.'
        schema:
          type: string
          enum:
          - id
          - info
          - status
      servers:
      - url: https://api.confluent.cloud
        description: Confluent Cloud API